Include "text.bb"
Include "Command.bb"
Include "Graphique.bb"
Include "newGame.bb"
Include "Confirmation.bb"

Type TypeMenu
	Field xmenu
	Field ymenu
	Field Largmenu
	Field Hautmenu
	Field nbMenu%
	Field espace%
	Field posCur%
	Field ImgBackTemp
	Field ImageForeGound
	Field idMenu
	
	Field SortMenu
	Field exitMenu
End Type

Global imgbackMenu
Global imgCurs

Global menuTimer

Global SortMenu

Global SonMenuBack
Global SonMenuOk
Global SonMenuChng
Global SonMenuChng2

Dim ListeMenu$(0)


Const nbCurFram=18


;----------------------------------------------------------------------
Function initMenu()
	imgCurs=LoadAnimImage("images\curs.png",64,64,0,nbCurFram)
	MaskImage(imgCurs,255,0,0)
	sonMenuChng=LoadSound("sfx\menuChng.wav")
	sonMenuChng2=LoadSound("sfx\menuChng2.wav")
	sonMenuOk=LoadSound("sfx\menuOk.wav")
	sonMenuBack=LoadSound("sfx\menuBack.wav")
	menuTimer=CreateTimer(30)
End Function 
;----------------------------------------------------------------------
Function menu_Show()
	FlushKeys()
	Local menu.TypeMenu = New TypeMenu
	menu\nbMenu=4
	menu\posCur=0
	menu\IdMenu=0
	menu\espace=50
	
	menu\xmenu%=300
	menu\ymenu%=200
	menu\largMenu%=450
	menu\hautMenu%=350

	Dim ListeMenu$(menu\nbMenu)
	ListeMenu(0)="New Game"
	ListeMenu(1)="Back to Game"
	ListeMenu(2)="Commands"
	ListeMenu(3)="Quit"
	
	menu\ImageForeGound=CreateImage(menu\largMenu,menu\hautMenu)
	GrabImage menu\ImageForeGound,menu\xmenu,menu\ymenu

	
	
	menu\ImgBackTemp=CreateImage(menu\largMenu,menu\hautMenu)
	GrabImage menu\ImgBackTemp,menu\xmenu,menu\ymenu
	drawImageFad(menu\ImgBackTemp,menu\ImgBackTemp,0.5)	
	SetBuffer  ImageBuffer(menu\ImgBackTemp)
	drawCadre(0,0,menu\largMenu,menu\hautMenu)
	
		
	menu\sortMenu=False
	menu\ExitMenu=False
	SetBuffer BackBuffer()
	cpt=0
	While ((Not menu\ExitMenu) Or (Not partieEnCours)) And (Not menu\sortMenu)
		
		Viewport(menu\xmenu,menu\ymenu,menu\largMenu,menu\hautMenu)
		Cls
		DrawImage menu\ImgBackTemp,menu\xmenu,menu\ymenu
		
		;titre
		drawText(150+menu\Xmenu,15+menu\Ymenu,"MENU")
		
		For i=0 To menu\nbMenu-1
			drawText(20+64+15+menu\Xmenu,80+15+menu\Ymenu+i*menu\espace,ListeMenu(i))
		Next
		DrawImage(imgCurs,20+15+menu\Xmenu,80+15+menu\Ymenu+menu\espace*menu\posCur-10,cpt)
		cpt=(cpt+1) Mod nbCurFram
		Flip
		WaitTimer(menuTimer)
		ReadAction(menu)
	Wend
	
	FreeImage menu\ImageForeGound
	FreeImage menu\ImgBackTemp
	Delete menu
	
End Function
;----------------------------------------------------------------------
Function ReadAction(menu.typeMenu)
	; dplacement dans le menu
	If KeyHit(200) Then 
		PlaySound(sonMenuChng2)
		menu\posCur=(menu\posCur-1) Mod menu\nbMenu
	EndIf
	If KeyHit(208) Then
		PlaySound(sonMenuChng)
		menu\posCur=(menu\posCur+1) Mod menu\nbMenu
	EndIf
	If menu\posCur<0 Then menu\posCur=menu\posCur+menu\nbMenu
	
	;valider
	If KeyHit(28) Then 
		PlaySound(sonMenuOk)
		doAction(menu) 
	EndIf
	;echap
	If KeyHit(1) Then 
		PlaySound(sonMenuBack)
		menu\ExitMenu=True
		Cls
		DrawImage menu\ImageForeGound,menu\xMenu,menu\yMenu
		Flip
		Cls
		DrawImage menu\ImageForeGound,menu\xMenu,menu\yMenu
	EndIf
End Function
;----------------------------------------------------------------------
Function doAction(menu.TypeMenu)
	Cls
	DrawImage menu\ImageForeGound,menu\xMenu,menu\yMenu
	Flip
	Cls
	DrawImage menu\ImageForeGound,menu\xMenu,menu\yMenu
	
	Select menu\IdMenu
		Case -1
			menu\sortMenu=menu\posCur=0
			menu\exitMenu=menu\posCur=1
		Case 0
			doActionMenu(menu)
		Case 1
			doActionPlayer(menu)
	End Select
End Function
;----------------------------------------------------------------------
Function doActionMenu(menu.TypeMenu)
	Select menu\posCur
		Case 0
			menu\sortMenu=newGame()
		Case 1
			menu\sortMenu=partieEnCours
		Case 2
			ShowCommands()
		Case 3
			If Confirmation_Show("  Do you want To quit :") Then
				menu\sortMenu=True
				QuitterJeu=True
			EndIf
	End Select
End Function