Global ImageDebri
Global ImgBaseBulet
Global ImgBulle
Global sonDebriExpl
Global sonBulleEpl
Global sonBulleLoop
Global sonMitraLoop 


Include "ship.bb"

Type typeBullet
	Field x#,y#
	Field vitesseX#,VitesseY#
	Field age#
	Field owner.typeShip
	Field typeB%
	Field image
End Type

Function initBullet()
	ImgBaseBulet=LoadImage("data\baseBulet.png")
	MaskImage(ImgBaseBulet,255,0,0)
	MidHandle(ImgBaseBulet)
	
	ImageDebri=LoadAnimImage("images\debri.png",15,15,0,10)
	MaskImage(ImageDebri,255,0,0)
	MidHandle(ImageDebri)
	
	ImgBulle = LoadImage("data\bulle.png")
	MaskImage(imgBulle,255,0,0)
	MidHandle(ImgBulle) 
	
	sonDebriExpl = LoadSound("sfx\litleExplosion.wav")
	sonBulleEpl  = LoadSound("sfx\BubleExp.wav")
	sonBulleLoop = LoadSound("sfx\BublesLOOP.wav")
	LoopSound(sonBulleLoop)
	sonMitraLoop = LoadSound("sfx\mitraLoop.wav")
	LoopSound(sonMitraLoop)
End Function
;----------------------------------------------------------------------
Function createBullet.typeBullet(ship.typeShip,TypeB)
	Local bullet.typeBullet=New TypeBullet
	bullet\TypeB=typeB
	
	Local vitesseB%
	Local decalx%=0
	Local decalY%=ship\tailleImg/2
	Select bullet\TypeB
	Case lazer
		vitesseB=10
		If ship\gun\cpt=0 Then
			decalx=-10 
		Else 
			decalx=10
		EndIf
	Case debri 
		vitesseB=5
	Case Base
		vitesseB=5
	Case Bulles
		vitesseB=5
	End Select
	
	bullet\owner=ship
	bullet\x=ship\x +Cos(ship\angle)*decalY + Sin(ship\angle) * decalx
	bullet\y=ship\y +Sin(ship\angle)*decalY + Cos(ship\angle) * decalx
	
	bullet\vitesseX=Cos(ship\angle)*vitesseB;ship\vitesseX +
	bullet\vitesseY=Sin(ship\angle)*vitesseB;ship\vitesseY + 
	
	
	Return Bullet
End Function
;----------------------------------------------------------------------
Function Bullet_nextState(bullet.typeBullet)
	Select bullet\TypeB
	Case debri
		bullet\vitesseY=bullet\vitesseY+gravite*3
		bullet\x=bullet\x+bullet\vitesseX
		bullet\y=bullet\y+bullet\vitesseY
		particles = CreateParticleBullet(bullet)
	Case bulles
		bullet\vitesseX=(bullet\vitesseX+Rand(-1,1)*.2)*.95
		bullet\vitesseY=(bullet\vitesseY+Rand(-1,1)*.2)*.95
		bullet\x=bullet\x+bullet\vitesseX
		bullet\y=bullet\y+bullet\vitesseY-.3
	Default 
		bullet\x=bullet\x+bullet\vitesseX
		bullet\y=bullet\y+bullet\vitesseY
	End Select
End Function
;----------------------------------------------------------------------
Function Bullet_TestColision(bullet.typeBullet,land.TypeLand)
	Local x%=Floor(bullet\x/tailleClip)
	Local Y%=Floor(bullet\y/tailleClip)
	If (Not isPtIn(bullet\x,bullet\y,0,0,land\larg,land\haut)) Then ;si a sort de l'cran
		Delete bullet
	Else
		If getImg(imgLand,x,y)<>0  Then  If ptCollide(tabland(x,y),x*tailleClip,y*tailleClip,bullet\x,bullet\y,0) Then
		Select bullet\TypeB
		Case Lazer
			bullet_explode(bullet,50)
		Case base
			bullet_explode(bullet,35)
		Case debri
			bullet_explode(bullet,25)
			PlaySound(sonDebriExpl)
		Case bulles
			PlaySound(sonBulleEpl)
		End Select
		
		particlesfume = CreateFumeMiniExplo(bullet\x,bullet\y)
		Delete bullet	
		EndIf
	EndIf	
	
End Function
;----------------------------------------------------------------------
Function bullet_testShipCollision()
	For ship.TypeShip=Each TypeShip
		If (bullets<>Null) Then If ptCollide(ship\image,ship\x,ship\y,bullets\x,bullets\y,ship_getImageNum(ship)) Then
			Select bullets\TypeB
			Case base 
				ship_degat(ship,Bullets\owner,5)
			Case Lazer
				ship_degat(ship,Bullets\owner,10)
			Case debri 
				ship_degat(ship,Bullets\owner,3)
			Case bulles
				ship\vitesseX=ship\vitesseX*.7
				ship\vitesseY=ship\vitesseY*.7
				PlaySound(sonBulleEpl)
			End Select 
			particlesfume = CreatefumeMiniExplo(bullets\x,bullets\y)
			Delete bullets
		EndIf
	Next
End Function
;----------------------------------------------------------------------
Function Bullet_affiche(bullet.typeBullet,deccalX%,deccalY%)	
	Select bullet\TypeB
	Case Lazer
		Color 245,10,10
		Line(bullet\x-deccalX,bullet\y-deccalY,-bullet\vitesseX*3+bullet\x-deccalX,-bullet\VitesseY*3+bullet\y-deccalY)
	Case debri
		;on affiche rien
	Case base
		DrawImage(ImgBaseBulet,bullet\x-deccalX,bullet\y-deccalY)
	Case Bulles
		DrawImage(ImgBulle,bullet\x-deccalX,bullet\y-deccalY)
	End Select
End Function
;----------------------------------------------------------------------
Function bullet_explode(bullet.TypeBullet,diametre%)
	land_drawOval(bullet\x,bullet\y,diametre)
End Function