Include "ship.bb"


Type typeParticle
	Field x#,y#
	Field vitesseX#,VitesseY#
	Field age#
	Field image
	Field vieissement
End Type

;----------------------------------------------------------------------
;constructeur de l'objt paticle (particule)
;----------------------------------------------------------------------
Function CreateParticle.TypeParticle(ship.typeShip)

	Local part.TypeParticle
	part= New TypeParticle
	part\vieissement=ship\dureeParticle
	part\image = ship\imagePower
	part\x=ship\x-Cos(ship\angle)*ship\rayonShip + Rand(-5,5)
	part\y=ship\y-Sin(ship\angle)*ship\rayonShip + Rand(-5,5)
	
	part\vitesseX=-Cos(ship\angle)*ship\pousee*10
	part\vitesseY=-Sin(ship\angle)*ship\pousee*10
		
	Return part
	
End Function
;----------------------------------------------------------------------
Function CreateParticleBullet.TypeParticle(Bullet.TypeBullet)

	Local part.TypeParticle
	part= New TypeParticle
	part\vieissement=0.8
	part\image = imageDebri
	part\x=Bullet\x + Rand(-5,5)
	part\y=Bullet\y + Rand(-5,5)	
	
	Return part
	
End Function
;----------------------------------------------------------------------
Function particle_nextState(part.TypeParticle)
	part\x=part\x+part\vitesseX
	part\y=part\y+part\vitesseY
	
	part\age=part\age+part\vieissement
End Function
;----------------------------------------------------------------------
;----------------------------------------------------------------------
Function particle_affiche(part.TypeParticle,decal_X%,decal_Y%)
	If (Not isPtIn(part\x,part\y,0,0,land\larg,land\haut)) Then ;si a sort de l'cran
		Delete part
	Else 
		If part\age>9 Then
			Delete part
		Else 
			DrawImage (part\image,part\x-decal_X,part\y-decal_Y,Int(part\age))
		EndIf
	EndIf
End Function
;----------------------------------------------------------------------