Global LargRadar%
Global hautRadar%
Global xRadar%
Global yRadar%
Global RayonRadar%
Global Xcoef#
Global Ycoef#
Global xMilieu%
Global YMilieu%
Global pasAngle%
Global angleRadar#

Global imageRadar

Global SonRadar
;----------------------------------------------------------------------
Function InitRadar(x%,y%)
	LargRadar=150
	hautRadar=150
	xRadar=x
	yRadar=y
	
	rayonRadar=LargRadar/2-5
	
	Local cote#=104
	
	Xcoef=cote/land\larg
	Ycoef=cote/land\haut
	Xmilieu=xRadar+LargRadar/2
	Ymilieu=Yradar+hautRadar/2
	pasAngle=1
	angleRadar=0
End Function
;----------------------------------------------------------------------
Function Radar_nextState()
	angleRadar=(angleRadar+pasAngle) Mod 360
End Function
;----------------------------------------------------------------------
Function show_radar()
	Viewport (xRadar,yRadar,LargRadar,hautRadar)
	DrawImage (imageRadar,xRadar,yRadar)
	Color 0,150,0
	For ships = Each TypeShip
		Plot(Xcoef*ships\x+xRadar+24,yCoef*ships\y+yRadar+24)
		angleShip%=CalcAbsoluteAngle(ships)
		If angleShip>=angleRadar And angleShip=<angleRadar+pasAngle Then PlaySound(SonRadar)
	Next

	Line(Xmilieu,Ymilieu,Xmilieu+Cos(angleRadar)*rayonRadar,yMilieu+Sin(angleRadar)*rayonRadar)
	
	SetBuffer BackBuffer()
	
End Function
;----------------------------------------------------------------------

Function CalcAbsoluteAngle%(ship.typeShip)
	Local x#=ship\x-land\larg/2
	Local y#=ship\y-land\haut/2
	Local Hypotenus#=Sqr(x*x+y*y)
	res%=ACos (x/Hypotenus)
	If y<0 Then res=360-res
	Return res
End Function