Const EtatNormal=0
Const EtatFindDirLibre=1
Const EtatTourne=2

Type TypeIa
	Field Ship.typeShip
	Field Etat%
	Field pas%
	Field angle%
End Type

;----------------------------------------------------------------------
Function CreateIa.typeIa(ship.typeShip)
	Local ia.typeIa=New typeIa
	ia\ship=ship
	ia\pas=1
	Return ia
End Function
;----------------------------------------------------------------------
Function Ia_NextState(ia.typeIa)
	If ia\Ship\gun\TypeG=Invincible Then 
		Local ship.typeShip=First TypeShip
		setDirection1(ia,ship\x,ship\y)
		ship_pouseOn(ia\ship)	
	Else 
		If colisionFuture(ia) Or colisionDevant(ia,ia\ship\angle) Then	
			ship_pouseOff(ia\ship)
			If ia\ship\vitesseRot>=0 Then 
				ia\ship\accelRot=+ia\ship\pouseeRot
			Else 
				ia\ship\accelRot=-ia\ship\pouseeRot
			EndIf
		Else
			ReduireVitRot(ia)
			ship_pouseOn(ia\ship)	
		EndIf
	EndIf
End Function

;----------------------------------------------------------------------
Function isThereObstacle%(ship.typeShip,xpt%,ypt%)
	;While x<>
End Function

;----------------------------------------------------------------------
;         Colisions
;----------------------------------------------------------------------
Function ColisionDevant(ia.typeIa,anglle%)
	newX#=ia\ship\x+Cos(anglle)*ia\ship\tailleImg
	newY#=ia\ship\y+Sin(anglle)*ia\ship\tailleImg
	Return land_isThereaColision(ia\ship,newX,newY)
End Function 
;----------------------------------------------------------------------
Function colisionFuture(ia.typeIa)
	newX#=ia\ship\x+ia\ship\vitesseX*100
	newY#=ia\ship\y+ia\ship\vitesseY*100
	
	Local angleVitesse%=CalcAngle(ia\ship\vitessex,ia\ship\vitesseY)
	
	Return ColisionDerive(ia) And Abs(differenceAngle(ia\ship\angle,angleVitesse))<20

End Function 
;----------------------------------------------------------------------
Function ColisionDerive(ia.typeIa)
	newX#=ia\ship\x+ia\ship\vitesseX*100
	newY#=ia\ship\y+ia\ship\vitesseY*100
	Return land_isThereaColision(ia\ship,newX,newY)
End Function 
;----------------------------------------------------------------------
;         Mouvements
;----------------------------------------------------------------------
Function ReduireVitRot(Ia.typeIA)
	If ia\ship\vitesseRot<=-ia\ship\pouseeRot Then ia\ship\accelRot=+ia\ship\pouseeRot
	If ia\ship\vitesseRot>=ia\ship\pouseeRot Then ia\ship\accelRot=-ia\ship\pouseeRot
End Function
;----------------------------------------------------------------------
Function setDirection1(ia.typeIa,x%,Y%)
	setDirection2(ia,CalcAngleFromShip(ia\ship,x,y)) 
End Function 
;----------------------------------------------------------------------
Function setDirection2(ia.typeIa,anglee%)
	If differenceAngle(anglee,ia\angle)>0 Then
		ia\ship\accelRot=+ia\ship\pouseeRot
	Else 
		ia\ship\accelRot=-ia\ship\pouseeRot
	EndIf	  
End Function 
;----------------------------------------------------------------------
;		Calculs d'angles
;----------------------------------------------------------------------
Function differenceAngle%(angle1%,angle2%)
	Local res%=angle1-angle2 
	If res>180 Then res=res-360
	If res<-180 Then res=res+360
	Return res
End Function
;----------------------------------------------------------------------
Function CalcAngleFromShip%(ship.typeShip,xpt%,ypt%)
	Return CalcAngle(xpt-ship\x,ypt-ship\y)
End Function
;----------------------------------------------------------------------
Function CalcAngle%(x%,y%)
	Local Hypotenus#=Sqr(x*x+y*y)
	res%=ACos (x/Hypotenus)
	If y<0 Then res=360-res
	Return res
End Function
;----------------------------------------------------------------------