Include "land.bb" 

Dim tabLand(0,0)
Dim tabBack(0,0)
Dim tabFront(0,0)
Global hautClp%
Global largClp%

Const imgBack=0
Const imgLand=1
Const imgFront=2


;--------------------------------------------
;                 Land
;--------------------------------------------
Function Land_loadBitmap(TypeImg%,path$,land.typeLand)
	
	hautClp% = land\hautClp
	largClp% = land\largClp
	Local img=LoadAnimImage(path,tailleClip,tailleClip,0,hautClp* largClp)
		
	setDim(TypeImg,largClp,hautClp)
	For j = 0 To hautClp-1
		For i = 0 To largClp-1
			If 	ImageIsEmpty(img,255,0,0,j*largClp+i) Then
				setImg(typeImg,i,j,0)
				
			Else
				imgTmp=CreateImage(tailleClip,tailleClip)
				SetBuffer ImageBuffer(imgTmp)
				DrawImage (img,0,0,j*largClp+i)
				MaskImage(imgTmp,255,0,0)
				setImg(typeImg,i,j,imgTmp)
			EndIf
		Next
	Next
	
	FreeImage img
End Function
;----------------------------------------------------------------------
Function Land_affiche(typeImg%,originX,originY,xRect,yRect,largRect,hautRect)
	Local decalClip_X%=xRect/tailleClip
	Local decalClip_Y%=YRect/tailleClip
	For j=decalClip_Y To (hautRect/tailleClip) +decalClip_Y +1
		For i=decalClip_X To (largRect/tailleClip)+decalClip_X +1
			img=getImg(typeImg,i,j)
			If img<>0
				DrawImage (img,originX+i*tailleClip-xRect, originY+j*tailleClip-yRect)	
			EndIf 
		Next
	Next  
End Function
;----------------------------------------------------------------------
Function land_isThereaColision(Ship.typeShip,Xpos#,Ypos#)
	
	Local xRect%=Xpos-ship\tailleImg
	Local yRect%=Ypos-ship\tailleImg
	Local largRect%=ship\tailleImg*2
	Local hautRect%=ship\tailleImg*2
	
	Local decalClip_X%=xRect/tailleClip
	Local decalClip_Y%=YRect/tailleClip
	ok = True
	j%=decalClip_Y
	
	While ok And (j<=(hautRect/tailleClip) +decalClip_Y) 
		i=decalClip_X
		While ok And (i<=(largRect/tailleClip)+decalClip_X) 
			Local imgT=getImg(imgLand,i,j)
			If imgT<>0
				ok= Not ImagesCollide(imgT,i*tailleClip,j*tailleClip,0,ship\image,Xpos,Ypos,ship_getImageNum%(ship))	
			EndIf 
			i=i+1
		Wend
		j=j+1
	Wend  	
	Return Not ok 
End Function

;----------------------------------------------------------------------
Function land_DrawOval(x%,y%,diametre%)
	xRect%=x-diametre/2
	yRect%=y-diametre/2
		
	Local decalClip_X%=xRect/tailleClip
	Local decalClip_Y%=YRect/tailleClip
	
	For j=decalClip_Y To (diametre/tailleClip) +decalClip_Y +1
		For i=decalClip_X To (diametre/tailleClip)+decalClip_X +1
			If getImg(imgLand,i,j)<>0
				SetBuffer ImageBuffer(tabland(i,j))
				Color 255,0,0
				Oval(xRect-i*tailleClip,yRect-j*tailleClip,diametre,diametre)
			EndIf
		Next
	Next   
End Function
;--------------------------------------------
;                 cases
;--------------------------------------------
Function getImg%(TypeImg%,i%,j%)
	If (i>=0) And (j>=0) And (i<largClp) And (j<hautClp) Then 
		Select TypeImg
	
		Case imgBack
			Return tabBack(i,j)
		Case imgLand
			Return tabLand(i,j)			
		Case imgFront
			Return tabFront(i,j)	
		Default
			Return 0
	
		End Select
	Else
		Return 0
	EndIf
End Function
;----------------------------------------------------------------------
Function setImg%(TypeImg%,i%,j%,img)
	Select TypeImg
		Case imgBack
			tabBack(i,j)=img
			
		Case imgLand
			tabLand(i,j)=img			
		Case imgFront
			tabFront(i,j)=img	
	End Select
	Return img
End Function
;----------------------------------------------------------------------
Function setDim(TypeImg%,larg%,haut%)
	Select TypeImg
		Case imgBack
			Dim tabBack(larg,haut)
		Case imgLand
			Dim tabLand(larg,haut)			
		Case imgFront
			Dim tabFront(larg,haut)	
	End Select
End Function
;----------------------------------------------------------------------
;----------------------------------------------------------------------
;----------------------------------------------------------------------
;----------------------------------------------------------------------
Function ImageIsEmpty(imgT%,red%,green%,blue%,Frame%)
	;empty=True
	;j%=0
	;SetBuffer ImageBuffer(img) 
	;While j<ImageHeight(img) And empty
	;	i%=0
	;	While i<ImageWidth(img) And empty
	;		GetColor(i,j)
	;		empty=(ColorRed()=red) And (ColorBlue()=blue) And (ColorGreen()=green)
	;		i=i+1
	;	Wend
	;	j=j+1
	;Wend
	;Return empty
	
	;SetBuffer FrontBuffer()
	;Cls
	;Text 10,10,img
	;DrawImage(100,100,img)
	;WaitKey()
	
	Local empty = True
	Local i%=0
	
	SetBuffer ImageBuffer(imgT,frame)
	While (i< 100) And  empty
		x%=Rand(0,tailleClip-1)
		y%=Rand(0,tailleClip-1)
		GetColor(x,y)
		;bug de blitz basic en full screen
		;empty =(ColorRed()=red) And (ColorBlue()=blue) And (ColorGreen()=green)
		empty =(ColorRed()>=248) And (ColorBlue()=0) And (ColorGreen()=0)
		i=i+1
	Wend
	Return empty
End Function
;--------------------------------------------
Function isPtIn(x%,y%,x_rect%,y_rect%,larg%,haut%)
	Return (x>=x_Rect) And (y>=y_rect) And (x<X_Rect+larg) And (y<y_rect+haut) 
End Function
;--------------------------------------------
Global point

Function ptCollide(imagel,ximg%,yimg%,xpt%,ypt%,frame%)
	Return ImagesCollide(imagel,ximg,yimg,frame%,point,xpt,ypt,0)
End Function 