Global ImgBonusVie
Global ImgBonusLazer
Global ImgBonusFake
Global ImgBonusBase
Global BonusFrame%
Global sonBonusGun

Const bonusvie=0 
Const BonusLazer=1
Const BonusMitra=2
Const BonusFake=3

Type TypeBonus
	Field X%,Y%
	Field TypeBonus%
End Type

;----------------------------------------------------------------------
Function createBonus.typeBonus()
	Local bonus.typeBonus = New typeBonus
	
	bonus\typeBonus=Rand(0,3)
		
	Repeat	 
		bonus\x=Rand(0,land\larg)
		bonus\y=Rand(0,land\haut)
	Until (Not Bonus_TestColisionLand(bonus))
	
	Return Bonus 
End Function 
;----------------------------------------------------------------------
Function initBonus()
	ImgBonusVie=LoadAnimImage("images\curs.png",64,64,0,nbCurFram)
	MaskImage(ImgBonusVie,255,0,0)
	MidHandle(ImgBonusVie)
	ImgBonusLazer=LoadAnimImage("data\bonusLazer.png",64,32,0,nbCurFram)
	MaskImage(ImgBonusLazer,255,0,0)
	MidHandle(ImgBonusLazer)
	ImgBonusFake=LoadAnimImage("data\bonusFake.png",64,64,0,nbCurFram)
	MaskImage(ImgBonusFake,255,0,0)
	MidHandle(ImgBonusFake)
	ImgBonusBase=LoadAnimImage("data\bonusBase.png",64,43,0,nbCurFram)
	MaskImage(ImgBonusBase,255,0,0)
	MidHandle(ImgBonusBase)
	
	sonBonusGun=LoadSound("sfx\bonusgun.wav")
End Function
;----------------------------------------------------------------------
Function Bonus_TestColisionLand(Bonus.TypeBonus)
	Local x%=Floor(Bonus\x/tailleClip)
	Local Y%=Floor(Bonus\y/tailleClip)
	If getImg(imgLand,x,y)<>0 Then
		Return ptCollide(tabland(x,y),x*tailleClip,y*tailleClip,bonus\x,bonus\y,0)
	EndIf
End Function
;----------------------------------------------------------------------
Function Bonus_Affiche(bonus.typeBonus,deccalX%,deccalY%)	
	Select bonus\typeBonus
		Case bonusVie 
			DrawImage(ImgBonusVie,bonus\x-deccalX,bonus\y-deccalY,BonusFrame/2)
		Case BonusLazer
			DrawImage(ImgBonusLazer,bonus\x-deccalX,bonus\y-deccalY,BonusFrame/2)
		Case BonusMitra
			DrawImage(ImgBonusBase,bonus\x-deccalX,bonus\y-deccalY,BonusFrame/2)
		Case BonusFake
			DrawImage(ImgBonusFake,bonus\x-deccalX,bonus\y-deccalY,BonusFrame/2)
	End Select
End Function 
;----------------------------------------------------------------------
Function Bonus_testShipCollision()
	For ship.TypeShip=Each TypeShip
		If (bonuses<>Null) Then If ptCollide(ship\image,ship\x,ship\y,bonuses\x,bonuses\y,ship_getImageNum(ship)) Then
			bonus_execute(ship,bonuses)
			Delete Bonuses
			PlaySound(sonBonusGun)
		EndIf
	Next
End Function
;----------------------------------------------------------------------
Function bonus_execute(ship.TypeShip,bonus.TypeBonus)
	Select (bonus\TypeBonus)
		Case bonusvie
			ship\vie=ship\VieMax
		Case bonusLazer
			Delete ship\gun
			ship\gun=createGun(lazer)
		Case BonusMitra
			Delete ship\gun
			ship\gun=createGun(Mitrailette)
		Case BonusFake
			Delete ship\gun
			Select Rand(0,1)
			Case 0 ship\gun=createGun(bulles)
			Case 1 ship\gun=createGun(Invincible)
		End Select
	End Select
End Function