Include "ship.bb"
Include "bullet.bb"

Global SonLazer
Global SonBase

Global ImgGunLazer
Global ImgGunMitra
Global ImgGunBase
Global ImgGunInvul
Global ImgGunBulles
Global ImgGunVide

Const vide=-2
Const invincible=-1
Const lazer=0
Const Debri=1
Const Base=2
Const Mitrailette=3
Const Bulles=4


Type typeGun
	Field TypeG%
	Field Cpt%
	Field LastBullet.TypeBullet
	Field Niveau#
End Type


Function initGun()
	ImgGunLazer=LoadImage("images/gunlazer.png")
	MaskImage(ImgGunLazer,0,0,255)
	ImgGunMitra=LoadImage("images/gunMitra.png")
	MaskImage(ImgGunMitra,0,0,255)
	ImgGunBase=LoadImage("images/gunBase.png")
	MaskImage(ImgGunBase,0,0,255)
	ImgGunInvul=LoadImage("images/guninvul.png")
	MaskImage(ImgGunInvul,0,0,255)
	ImgGunVide=LoadImage("images/gunVide.png")
	MaskImage(ImgGunVide,0,0,255)
	ImgGunBulles	=LoadImage("images/gunBulles.png")
	MaskImage(ImgGunBulles,0,0,255)
End Function
;----------------------------------------------------------------------
Function createGun.typeGun(TypeG%)
	Local gun.typeGun=New TypeGun
	gun\TypeG=TypeG
	gun\Niveau=100
	Return Gun
End Function
;----------------------------------------------------------------------
Function gun_shoot(Ship.typeShip)
		If KeyHit(ship\command\Fire) Then
			Select ship\gun\TypeG
				Case lazer
					PlaySound(SonLazer)
					ship\gun\cpt=(ship\gun\cpt+1) Mod 2
					bullets = createBullet(ship,lazer)
				Case base 
					If ship\gun\LastBullet=Null Then 
						bullets = createBullet(ship,base)
						PlaySound(SonBase)
						ship\gun\LastBullet = bullets
					EndIf
			End Select
		Else;on laisse apuil sur la touche
			Select ship\gun\TypeG
				Case Mitrailette
					If ship\gun\cpt=0 Then
						If Not ChannelPlaying(ship\chnlGun) Then ship\chnlGun=PlaySound(sonMitraLoop)
						bullets = createBullet(ship,base)
					EndIf
					ship\gun\cpt=(ship\gun\cpt+1) Mod 7
				Case debri
					bullets = createBullet(ship,debri)
				Case Bulles
					If ship\gun\cpt=0 Then
						If Not ChannelPlaying(ship\chnlGun) Then ship\chnlGun=PlaySound(sonBulleLoop)
						bullets = createBullet(ship,Bulles)
					EndIf
					ship\gun\cpt=(ship\gun\cpt+1) Mod 7
			End Select 
		EndIf
End Function 
;----------------------------------------------------------------------
Function getImgGun(ship.typeShip)
		Select ship\gun\typeG
			Case lazer
				Return ImgGunLazer
			Case Base
				Return ImgGunBase
			Case Mitrailette
				Return imgGunMitra
			Case invincible
				Return imgGunInvul
			Case bulles
				Return imgGunbulles
			Default
				Return imgGunVide
	End Select
End Function
;----------------------------------------------------------------------
Function diminuGun(Ship.typeShip)
	ship\gun\niveau=ship\gun\niveau-.1
	If ship\gun\niveau <=0 Then 
		Delete ship\Gun 
		ship\gun=createGun(Vide)
	EndIf
End Function