Include "ship.bb"
Include "bitmap.bb"

Global gravite#=0.05

;L'image du niveau est dcoup en image de 64/64 pour optimiser l'affichage
Const tailleClip=64

Const MaxPosShip=2
Dim shipPos(2,MaxPosShip)

Type typeland
	;Field imageLand
	;Field imageBack
	;Field imageFront
	Field imageBackStar
	Field haut%,larg%
	Field hautClp%,largClp%;nrb de cars de 64*64 en hauteur * largeur
	End Type
;----------------------------------------------------------------------
Function createLand.typeLand(path$)
	Local land.typeLand = New typeLand
		Viewport(0,0,GraphicsWidth(),GraphicsHeight()) 
		Cls
		drawText 200,200,"Chargement du niveau"
		Flip
		
		fich=ReadFile(path+"data.lnd")
		land\larg=file_ReadFloat(fich)
		land\haut=file_ReadFloat(fich)
		
		CloseFile(fich) 
		
		shipPos(0,0)=200
		shipPos(0,1)=200
		shipPos(1,0)=700
		shipPos(1,1)=700
		
		land\hautClp=land\haut/tailleClip
		land\largClp=land\larg/tailleClip
		
		Land_loadBitmap(imgLand,path+"land.png",land)
		Land_loadBitmap(imgFront,path+"front.png",land)
		Land_loadBitmap(imgBack,path+"back.png",land)
		land\imageBackStar =LoadImage(path+"backStar.png") 
		MaskImage(land\imageBackStar,255,0,0)
	Return land
End Function 
;----------------------------------------------------------------------
Function DeleteLand(land.typeLand)
	For j = 0 To hautClp-1
		For i = 0 To largClp-1
			If tabLand(i,j)<>0	Then FreeImage(tabLand(i,j))
			If tabback(i,j)<>0	Then FreeImage(tabback(i,j))
			If tabfront(i,j)<>0	Then FreeImage(tabfront(i,j))
		Next
	Next
	If land\imageBackStar <> 0 Then FreeImage land\imageBackStar
	Delete land
End Function